#include "StepModelLoader.h"

#include <Message.hxx>
#include <Standard_ArrayStreamBuffer.hxx>
#include <TDocStd_Application.hxx>
#include <TDocStd_Document.hxx>
#include <BinXCAFDrivers.hxx>
#include <STEPCAFControl_Reader.hxx>

using std::istream;

StepModelLoader::StepModelLoader(const Standard_CString fileName, const Standard_ArrayStreamBuffer& modelFileStream) :
    _fileName(fileName),
    _modelFileStream(const_cast<Standard_ArrayStreamBuffer*>(&modelFileStream))
{ 
}

StepModelLoader::~StepModelLoader()
{
}

Handle(TDocStd_Document) StepModelLoader::Load()
{
    //Create XDE document.
    Handle(TDocStd_Application) app = new TDocStd_Application;
    BinXCAFDrivers::DefineFormat(app);
    Handle(TDocStd_Document) doc;
    app->NewDocument("BinXCAF", doc);

    STEPCAFControl_Reader cafReader;
    // STEPControl_Reader& reader = cafReader.ChangeReader();
    
    return doc;
}